<template>
  <div class="container flex mx-auto border-t border-dark">
    <div class="border-r border-dark pt-12 pr-8 w-3/4">
      <h2 class="text-xl mb-8">Produk Health Kit</h2>
      <div v-if="is_loading">Memuat Produk...</div>
      <div v-else>
        <alert-error v-if="error">
          {{ error.message }}
        </alert-error>
        <div v-else class="grid grid-cols-4 gap-6 pb-12">
          <nuxt-link v-for="product in items" :key="product.id" :to="`products/${product.id}`">
            <product-card>
              <img
                :src="product.image"
                :title="product.name"
                :alt="product.name"
                class="w-full"
                slot="header"
              />

              <div class="pt-6 p-3 text-left">
                <div class="italic">
                  {{ product.name }}
                </div>
                <div>
                  {{ product.price | currencyFormat }}
                </div>
                <div class="text-data-blue uppercase">
                  {{ product.producer }}
                </div>
              </div>
            </product-card>
          </nuxt-link>
        </div>
      </div>
    </div>
    <div class="flex-grow pl-8 w-1/4">
      <h2 class="text-xl pb-8">Filter</h2>
      <div class="w-full relative flex items-center">
        <select class="px-4 py-2 w-full text-black">
          <option value disabled selected>Pilih Produsen</option>
          <!-- <option v-for="produsen in produsenList" :key="produsen" :value="produsen">
            {{ produsen }}
          </option>-->
        </select>
        <img src="~/assets/icons/caret.svg" class="icon absolute" alt />
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex';

import currencyFormat from '~/mixins/filters/currencyFormat';

import AlertError from '~/components/alerts/error.vue';
import ProductCard from '~/components/ProductCard.vue';

export default {
  async asyncData({
    isDev,
    route,
    store,
    env,
    params,
    query,
    req,
    res,
    redirect,
    error
  }) {
    if (!store.state.products.rawData) await store.dispatch('products/fetchAll')
  },

  components: {
    AlertError,
    ProductCard,
  },

  mixins: [
    currencyFormat,
  ],

  computed: {
    ...mapGetters({
      items: 'products/items'
    }),
    ...mapState({
      error: state => state.products.error,
      is_loading: state => state.products.is_loading
    })
  }

  // created: function() {
  //   this.produsenList = [...new Set(this.dummyData.map(data => data.produsen))];
  //   this.produsenList.push('Semua Kota');
  //   this.filter = '';
  // },

  // computed: {
  //   filteredData: function() {
  //     if (!this.filter || this.filter === 'Semua Kota') {
  //       return this.dummyData;
  //     }

  //     return this.dummyData.filter(item => item.produsen === this.filter);
  //   },
  // },
}
</script>

<style lang="postcss" scoped>
select {
  /* for Firefox */
  -moz-appearance: none;
  /* for Chrome */
  -webkit-appearance: none;
}

/* For IE10 */
select::-ms-expand {
  display: none;
}

.border-dark {
  border-color: #363636;
}

.icon {
  pointer-events: none;
  right: 1rem;
}
</style>
